package algorithms.priorityqueues;

import java.util.Set;

// interface for a priority queue
public interface PriorityQueue<K,V> {
	public void insert(PriorityQueueNode<K,V> x);
	public PriorityQueueNode<K,V> getMinimum();
	public PriorityQueueNode<K,V> deleteMinimum();
	public void merge(PriorityQueue<K,V> q2);
	public void decreasePriority(PriorityQueueNode<K,V> node, int newValue);
	public boolean delete(PriorityQueueNode<K,V> node);
	public PriorityQueueNode<K,V> getNode(K key);
	public Set<K> getKeySet();
	
	public boolean checkQueueIntegrity();
	public int size();
}